package org.greenstone.server;

import java.awt.BorderLayout;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.event.*;

import org.greenstone.server.BaseServerSettings;

public class Server2Settings extends BaseServerSettings implements ChangeListener, ActionListener
{
    protected JComboBox prefix_combobox;

    public Server2Settings(BaseServer server) 
    {
	super(server);
    }

    protected JPanel createServletPanel()
    {
	portNumber_spinner.addChangeListener(this);

	JLabel prefix_label = new JLabel(server.dictionary.get(BaseServer.Property.SERVER_SETTINGS+".URL"));

	prefix_combobox = new JComboBox();
	prefix_combobox.setEditable(true);
	prefix_combobox.addItem(server.getBrowserURL());
	prefix_combobox.addActionListener(this);

	JPanel comb_panel = new JPanel();
	comb_panel.setLayout(new BorderLayout());
	comb_panel.add(prefix_label, BorderLayout.NORTH);
	comb_panel.add(prefix_combobox, BorderLayout.CENTER);
	return comb_panel;
    }

    public String onSave() 
    {
	return "";
    }

    public void save(ScriptReadWrite scriptReadWrite, ArrayList newFileLines) 
    {
	String newAutoEnter = autoEnter.isSelected() ? "1" : "0";
	newFileLines = scriptReadWrite.queryReplace(newFileLines, BaseServer.Property.AUTOSTART, newAutoEnter);
    }

    public void stateChanged(ChangeEvent e) {
	int portNumber = ((Integer)portNumber_spinner.getValue()).intValue();
	String url = (String)prefix_combobox.getSelectedItem();
	url.replace('\\', '/');
	String pre = "";
	if(url.indexOf("http://") != -1) {
	    pre = "http://";
	    url = url.substring(7);
	}

	String[] parts = url.split("/");
	String prefix = parts[0];

	int colon = prefix.indexOf(':');
	if(colon != -1) {
	    prefix = prefix.substring(0, colon);
	} 
	
	url = pre + prefix + ":" + portNumber;
	for(int i = 1; i < parts.length; i++) {
	    url = url + "/" + parts[i];
	}

	prefix_combobox.setSelectedItem(url);	
    }

    public void actionPerformed(ActionEvent e) {
	String url = (String)prefix_combobox.getSelectedItem();
	int portNumber = 80;

	String oldUrl = url;
	if(url.indexOf("http://") != -1) {
	    url = url.substring(7);
	}
	int colon = url.indexOf(':');
	int slash = url.indexOf('/');
	if(slash == -1) {
	    slash = url.length();
	}
	if(colon != -1) {
	    url = url.substring(colon+1, slash);
	    try { 
		portNumber_spinner.setValue(Integer.decode(url));
	    } catch(NumberFormatException nfe) { // couldn't parse port number
		// not an integer, leave portnumber at 80
		String oldNum = portNumber_spinner.getValue().toString();
		oldUrl = oldUrl.replaceFirst(oldNum, "80");
		portNumber_spinner.setValue(new Integer(80));
	    }
	} else { // no port number
	    oldUrl = oldUrl.replaceFirst(url, url+":80");
	    portNumber_spinner.setValue(new Integer(80));
	}
    }

}
